function DatosOut = ConsistencyDegreesJOSA2016(DatosIn,Alfa,Gamma,Alfa2,Gamma2)


[a b] = size(DatosIn);
%a debe ser 9
%Datos out sera como DatosIn pero aadiendo el grado fuzzy de confianza...
DatosOut = zeros(14,b);
%figure
%Para cada dato del conjunto
for i=1:1:b
    i
    ParActuali = DatosIn(:,i);
    %Vamos a calcular la pertenencia al conjunto difuso de vecinos cercanos
    %de todos los demas datos    
    Membership = zeros(1,b); %Guardara la funcion de pertenencia de cada muestra
    NVecinosTi = 0;
    indice = 0;
    for j=1:1:b
        if (i==j)
            %La muestra en estudio no pertenece (alteraria el resultado)
            Membership(j) = 0;
        else
            indice = indice + 1;
            ParActualj = DatosIn(:,j);
            %%Ahora calculamos la distancia entre los puntos medios entre
            %%las muestras
            %Medioi = (ParActuali(2:4)+ParActuali(5:7))/2;
            %Medioj = (ParActualj(2:4)+ParActualj(5:7))/2;
            %Distanciaij2 = sqrt(sum((Medioi-Medioj).^2));
            %%Calculamos el grado de pertenencia de la muestra por la que
            %%vamos
            %CercaniaCentros = 1-SMshp(Distanciaij2,Alfa,Gamma);
            
            %Calculamos la distancia entre los dos pares y los grados en
            %que son pequeas
            [DeltaM1 DeltaM2] = DistanciaParesMuestras(ParActuali(2:4),ParActuali(5:7),ParActualj(2:4),ParActualj(5:7));
            DeltaM1P = 1-SMshp(DeltaM1,Alfa,Gamma);
            DeltaM2P = 1-SMshp(DeltaM2,Alfa,Gamma);
            
            %Similitud entre los DV de los pares
            DDV = abs(ParActuali(9)-ParActualj(9));
            SimilitudDV = 1-SMshp(DDV,Alfa2,Gamma2);
            %CercaniaCentros*SimilitudDV
            Membership(j) = DeltaM1P*DeltaM2P*SimilitudDV;
            %Numero total de vecinos, son aquellos con pertenencia distinta de 0
            if (Membership(j) > 0)
                NVecinosTi = NVecinosTi +1;
            end
        end
    end
    %Ahora calculamos la media y la desviacion tipica de los valores
    %ponderados por su pertenencia al conjunto fuzzy
    %Comprobamos si no hay ningun dato en el conjunto
    if (sum(Membership)==0)
        'No hay vecinos en el conjunto'
        %No podemos dudar de la muestra, por lo que ponemos certeza 1
        DatosOut(:,i) = [ParActuali; 0; 0; 0; 1; 0];
    else        
        %Calculamos la media ponderada
        Num = sum(Membership.*DatosIn(8,:));
        Den = sum(Membership);
        Media = Num/Den;
        
        %Ahora la desviacion tipica ponderada
        Num = sum(Membership.*((DatosIn(8,:)-Media).^2));
        Den = sum(Membership);
        Desviacion = sqrt(Num/Den);
        
        %Ahora calculamos otra medida fuzzy de confianza en el dato. Medimos la
        %distancia fuzzy a la media con respecto a la desviacion tipica
        %observada. Usamos la metrica standard de george y veeramani
        FuzzyMatch = Desviacion / (Desviacion+abs(ParActuali(8)-Media));
        FuzzyMatchMediana = 0;
        if (sum(Membership) >= 6 || ((sum(Membership) >= 3) && (sum(Membership)/NVecinosTi)>=0.35))
            Significativo = 1;
        else
            Significativo = 0;
        end
        DatosOut(:,i) = [ParActuali; sum(Membership); NVecinosTi; Significativo; FuzzyMatch; 0];

        %'Dato para el que calculamos la confianza'
        % [DatosIn(8,i) ParActuali(8)]
        %'Media y desviacion tipica ponderadas'
        %[Media Desviacion]
        %'Confianza segun FM'
        %FuzzyMatch 
        %pause
    end
end
            
        
        
