function [DatosOut, ParesInconsistentes] = InconsistenciesFuzzyRule2(DatosIn,umbral)

[a b] = size(DatosIn);
%a debe ser 11
%Datos out sera como DatosIn pero aadiendo el grado fuzzy de confianza...
DatosOut = zeros(14,b);
ParesInconsistentes = zeros(1,11);
%figure
%Para cada dato del conjunto
for i=1:1:b
    i
    ParActuali = DatosIn(:,i); %Par a analizar
    InconsistenciaDEi = 0;
    InconsistenciaDEiMax = 0;
    NVecinosi = 0;
    NVecinosTi = 0;
    %Vamos a calcular el grado mximo y medio de inconsistencia analizando dato por dato
    %lo comparamos con el siguiente en adelante
    for j=(i+1):1:b
        if (i==j) 
            %No hacemos nada
        else
            ParActualj = DatosIn(:,j);
            %ParActuali
            %ParActualj
        
            %Ahora calculamos la distancia entre los dos pares y los grados en
            %que son pequeas
            [DeltaM1 DeltaM2] = DistanciaParesMuestras(ParActuali(2:4),ParActuali(5:7),ParActualj(2:4),ParActualj(5:7));
            DeltaM1P = 1-SMshp(DeltaM1,1,5);
            DeltaM2P = 1-SMshp(DeltaM2,1,5);
                
            %Diferencia entre los DVs y grado en que es pequea
            DV1 = ParActuali(9);
            DV2 = ParActualj(9);
            DDV = abs(DV1-DV2);
            DDVP = 1-SMshp(DDV,0.2,1);

            %Diferencia entre los DEs y grado en que es grande
            DE1 = ParActuali(10);
            DE2 = ParActualj(10);
            DDE = abs(DE1-DE2);
            DDEG = SMshp(DDE,1,2);
        
        
            %Grado de vecindad entre las muestras i y j
            GradoVecindad = DeltaM1P*DeltaM2P*DDVP;
        
            %acumulamos el nmero de vecinos como la suma de las certezas de
            %los 3 primeros antecedentes de la regla DelaM1P, DeltaM2P y DDEP
            NVecinosi = NVecinosi + GradoVecindad;

            %Grado de inconsistencia de la muestra i respecto a la j
            GradoDE = DeltaM1P*DeltaM2P*DDVP*DDEG;

            %Si el grado es superior a un umbral, metemos las dos muestras
            %en el conjunto de pares inconsistentes
            if (GradoDE > umbral)
                ParesInconsistentes = [ParesInconsistentes;
                                       [ParActuali' GradoDE];
                                       [ParActualj' GradoDE]]
            end

            %sumamos las inconsistencias ponderadas por el grado de vecindad
            InconsistenciaDEi = InconsistenciaDEi + GradoVecindad*GradoDE;
            %Luego dividiremos por el nmero de vecinos para normalizar
        
            %acumulamos el nmero de vecinos totales como aquellos que tienen
            %el Grado de vecindad distinto de 0
            if ( GradoVecindad > 0)
                NVecinosTi = NVecinosTi + 1;
            end
            if (GradoDE > InconsistenciaDEiMax)
                InconsistenciaDEiMax = GradoDE;
            end
            %Inconsistenciai
            %pause
        end        
    end
    %normalizamos la media ponderada
    if (NVecinosi > 0)
        InconsistenciaDEi = InconsistenciaDEi/NVecinosi;
    else %Si no hay vecinos, no podemos decir que sea inconsistente
        InconsistenciaDEi = 0;
    end
    
    DatosOut(:,i) = [ParActuali; NVecinosi; NVecinosTi; InconsistenciaDEi; InconsistenciaDEiMax ];
end