function M = SMshp(x,alpha,gamma)
%function M = SMshp(x,alpha,gamma)
%Function de pertenencia S tal y como esta descrita en el libro E.E. Kerre, Fuzzy Sets
%and Approximate Reasoning, Xian Jiaotong University Press (1999)

beta = (alpha+gamma)/2;

if (x < alpha)
    M = 0;
elseif (x < beta)
    M = 2*(((x-alpha)/(gamma-alpha))^2);
elseif (x < gamma)
    M = 1 - 2*(((x-gamma)/(gamma-alpha))^2);
else 
    M = 1;
end